#!/usr/bin/perl -w

# LSB Test Execution Framework
# Results Page Module (tests_results.pl)
#
# Copyright (C) 2006-2007 Free Standards Group. All rights reserved.
#
# This program has been developed by ISP RAS for FSG.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

use Templates;
use Fcntl ':flock';
use Fcntl ':seek';

if ($_POST{"remove"}) {
	if (open(FILE, "+<".$CONFIG{"RESULTS_DIR"}."/HISTORY")) {
		flock(FILE, LOCK_EX);
		while(<FILE>) {
			s/[\r\n]//g;
			my $path = $CONFIG{"RESULTS_DIR"}."/$_";
			if (-d $path) {
				if ($_POST{$_} and ($_POST{$_} eq "on")) {
					system("rm -rf $path");
				}
				else {
					push @list, $_;
				}	
			}
		}
		seek(FILE, 0, SEEK_SET);
		truncate(FILE, 0);
		print FILE join("\n", @list)."\n";
		flock(FILE, LOCK_UN);
		close(FILE);
		print "HTTP/1.0 302 Moved\nLocation: tests_results.pl\n\n";
		exit;
	}
	else {
		print STDERR "Cannot open HISTORY file!\n";
	}
}

print "HTTP/1.0 200 OK\n";
print "Content-type: text/html\n\n";

print_header("Test Results", "results");

if ($_GET{"details"}) {
	my $name = "test_log.html";
	if ($_GET{"cert"} and -f $CONFIG{"RESULTS_DIR"}."/".$_GET{"details"}."/cert.html") {
		$name = "cert.html";
	}
	if (open(FILE, $CONFIG{"RESULTS_DIR"}."/".$_GET{"details"}."/".$name)) {
		my $transfer = 0;
		while (<FILE>) {
			if (m/<body>/) {
				s/^.*<body>\n?//i;
				$transfer = 1;
			}
			if ($transfer) {
				s/(<\/body>|<\/html>)\n?//i;
				print $_;
			}
		}
		close(FILE);
	}
	else {
		print "<b><font color=\"red\">Sorry, the report '".$_GET{"details"}."' cannot be opened!</font><br />\nReason: $!</b>\n";
	}
}
else {
	print "<h1>Test Results</h1>\n";

	print "<form method=\"post\" action=\"tests_results.pl\" name=\"results_list\">\n<table class=\"main\">\n";
	print "  <tr>\n    <td><input type='checkbox' name='check_all' id='check_all' onclick='javascript:check_unckeck_all();' /></td>\n";
	print "    <th width=\"170px\">Date/Time</th>\n";
	print "    <th width=\"170px\">Summary</th>\n";
	print "    <th width=\"300px\">Comment</th>\n  </tr>\n";
	my @list = ();
	if (open(FILE, "+<".$CONFIG{"RESULTS_DIR"}."/HISTORY")) {
		flock(FILE, LOCK_EX);
		while(<FILE>) {
			s/[\r\n]//g;
			push @list, $_ if (-d $CONFIG{"RESULTS_DIR"}."/$_");
		}
		seek(FILE, 0, SEEK_SET);
		truncate(FILE, 0);
		print FILE join("\n", @list)."\n";
		flock(FILE, LOCK_UN);
		close(FILE);
		@list = reverse(@list);
		foreach my $name (@list) {
			$_ = $CONFIG{"RESULTS_DIR"}."/$name";
			my @summary = ();
			my @comment = ();
			my $current_field = \@summary;
			if (open(FILE, "$_/INFO")) {
				while (<FILE>) {
					s/&/&amp;/g;
					s/</&lt;/g;
					s/>/&gt;/g;
					s/[\r\n]//g;
					if ($_ eq "") {
						$current_field = \@comment;
						next;
					}
					push @$current_field, $_;
				}
				close(FILE);
			}
			my $fail = -1;
			foreach (@summary) {
				if (m/Verdict: (\S+)/i) {
					if ($1 eq "Success") {
						$fail = 0;
					}
					elsif ($1 eq "Failed") {
						$fail = 1;
					}
					pop(@summary);
					last;
				}
				# Align numbers by right side (6 digits max)
				s/^(\d+) /("&nbsp;"x(6-length($1))).$1." "/e;
			}
			my $jsummary = join("<br />", @summary);
			$jsummary = "&nbsp;" if ($jsummary eq "");
			my $jcomment = join("<br />", @comment);
			$jcomment = "&nbsp;" if ($jcomment eq "");
			my $image = "";
			my $img_alt = "";
			my $cert_param = "";
			if ($fail == -1) {
				$fail = ($jsummary =~ m/(\d+) Tests Failed/) ? $1 : -1;
			}
			if (-f $CONFIG{"RESULTS_DIR"}."/$name/cert.html") {
				$cert_param = "&cert=1";
				if ($fail) {
					$image = "CertFailed.png";
					$img_alt = "CertFail";
				}
				else {
					$image = "CertPassed.png";
					$img_alt = "CertPass";
				}
			}
			else {
				if ($fail) {
					$image = "TestFailed.png";
					$img_alt = "Fail";
				}
				else {
					$image = "TestPassed.png";
					$img_alt = "Pass";
				}
			}
			my $show_name = $name;
			$show_name =~ s/^[^\-]*\-[^\-]*\-([^\-]*)\-([^\-]*)\-([^\-]*)\-([^\-]*)h\-([^\-]*)m\-([^\-]*)s/$3.$2.$1&nbsp;$4:$5:$6/;
			print "  <tr>\n    <td><input type='checkbox' name='$name' onclick='javascript:update_state();' /></td>\n";
			print "    <td><img src=\"images/$image\" alt=\"$img_alt\" width=\"33\" height=\"30\" />&nbsp;<a href=\"tests_results.pl?details=$name$cert_param\">$show_name</a></td>\n";
			print "    <td><code>$jsummary</code></td>\n";
			print "    <td valign=\"top\">$jcomment</td>\n  </tr>\n";
		}
	}
	print "</table>\n<br /><input type=\"submit\" name=\"remove\" id=\"remove_button\" value=\"Remove selected\" disabled=\"disabled\" onclick='javascript:return confirm_remove();' /></form>\n";
	print <<DATA;
<script language="javascript" type="text/javascript">
// <![CDATA[
function count_checked() {
	var num = 0;
	var form = document.results_list;
	for (var i=0; i<form.length; ++i) {
		if ((form[i].type.toLowerCase() == "checkbox") && (form[i].name != "check_all") && form[i].checked) {
			++num;
		}
	}
	return num;
}

function update_state() {
	var elem = document.getElementById("remove_button");
	if (elem) {
		var num = count_checked();
		elem.disabled = (num == 0);
	}
}

function check_unckeck(box, check) {
	temp = box.onchange;
	box.onchange = null;
	box.checked = check;
	box.onchange = temp;
}

function check_unckeck_all() {
	var elem = document.getElementById("check_all");
	if (elem) {
		var checked = elem.checked;
		var form = document.results_list;
		for (var i=0; i<form.length; ++i) {
			if ((form[i].type.toLowerCase() == "checkbox") && (form[i].name != "check_all"))
				check_unckeck(form[i], checked);
		}
		update_state();
	}
}

function confirm_remove() {
	var num = count_checked();
	if (num == 0) {
		alert("Nothing selected!");
		return false
	}
	else
		return confirm("Do you wish to delete " + num + " selected report(s)?");
}
// ]]>
</script>
DATA
}

print_footer();
